{# Copyright 2020 Karlsruhe Institute of Technology
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at
 #
 #     http://www.apache.org/licenses/LICENSE-2.0
 #
 # Unless required by applicable law or agreed to in writing, software
 # distributed under the License is distributed on an "AS IS" BASIS,
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and
 # limitations under the License. #}

{% extends "settings/base.html" %}

{% block breadcrumbs %}
  {{ super() }}
  {% snippet "breadcrumb", url=url_for("settings.manage_services"), title=title %}
{% endblock %}

{% block content %}
  <div class="card">
    {% include "settings/snippets/menu.html" %}

    <div class="card-body">
      {% if providers %}
        <p>
          <small class="text-muted">
            <i class="fas fa-info-circle"></i>
            {% trans trimmed %}
              Note that to completely disconnect a previously connected service, access must also be revoked on the
              service's website.
            {% endtrans %}
          </small>
        </p>
        {% for provider in providers %}
          <div class="row align-items-center">
            <div class="col-md-8">
              <span class="h5">{{ provider.title }}</span>
              {% if provider.is_connected %}
                <span class="badge badge-light border border-muted font-weight-normal ml-1">
                  {% trans %}Connected{% endtrans %}
                </span>
              {% endif %}
              {% if provider.website %}
                <br>
                <a href="{{ provider.website }}">
                  <small>
                    <i class="fas fa-external-link-alt mr-1"></i> {% trans %}Visit website{% endtrans %}
                  </small>
                </a>
              {% endif %}
              {% if provider.description %}
                <div class="mt-2">{{ provider.description }}</div>
              {% else %}
                <div class="text-muted mt-2">
                  <em>{% trans %}No description.{% endtrans %}</em>
                </div>
              {% endif %}
            </div>
            <div class="col-md-4 mt-2 mt-md-0 d-md-flex justify-content-end">
              {% if provider.is_connected %}
                <submission-form action="?disconnect={{ provider.name }}"
                                 selector="#disconnect_{{ provider.name }}"
                                 :check-dirty="false">
                  {{ render_csrf() }}
                  <button id="disconnect_{{ provider.name }}" class="btn btn-sm btn-danger">
                    <i class="fas fa-unlink"></i> {% trans %}Disconnect service{% endtrans %}
                  </button>
                </submission-form>
              {% else %}
                <div>
                  <a href="{{ url_for('settings.oauth2_login', provider=provider.name) }}" class="btn btn-sm btn-light">
                    <i class="fas fa-link"></i> {% trans %}Connect to service{% endtrans %}
                  </a>
                </div>
              {% endif %}
            </div>
          </div>

          {% if not loop.last %}
            <hr>
          {% endif %}
        {% endfor %}
      {% else %}
        <span class="text-muted">
          <em>{% trans %}No services have been registered yet with this application.{% endtrans %}</em>
        </span>
      {% endif %}
    </div>
  </div>
{% endblock %}
